/*
 * NOTE: If the function has parameters it is important to make sure they are
 * in the correct units eg coordinate units or meters this is unresolved at
 * the moment but the feeling is that the program will either go over to
 * coordinate units with internal transformation in the function or will
 * trail two seperate values for each coordinate one in meters and one in
 * coordinate units at present it is not clear which owuld be quicker but the
 * former appears to be more straight forward *********
 * 
 */
#define R2 		.7071068118654752440	/* one over root 2 */
#define PIX2 		(2.0*3.1415265358979323846)	/* 2 PI */
#define K               (PIX2/wavelength)
#define MAX_STRING 	64
#define FALSE 		0
#define TRUE 		1

#define plane 		0
#define gaussian 	1
#define doughnut 	2
#define MAX_OPTIONS	2500
#define	APERTURE_OFF	0
#define CGH_TYPE	double

typedef int    BOOL;
typedef double 	DIST_T;

/* cost base */
typedef struct COST_DATA{
        double signal;
        double noise;
}       COST_DATA;
 
 
/* cost type */
typedef struct COST_T{
	COST_DATA newc;
	COST_DATA oldc;
}	COST_T;

/* cost structure */
typedef struct COST{
	double oldcost;
	double newcost;
}	COST;

/* point data type */
typedef struct POINT {
	float           x;
	float           y;
}               POINT;

typedef char  	HDATA;

/* image complex amplitude */


/* hologram descriptor */
typedef struct HOLODATA {
	/* hologram descriptor */
	POINT           pixelsize;
	int             xpixels;
	int             ypixels;
	int             phaselevels;
	float           wavelength;
	float 		beamdata;
	HDATA          *hdata;
	int	       *aperture;
	int	        beam_type;
}               HOLODATA;	/* hologram descriptor */


/* image descriptor */
typedef struct CHANGE_T {
	BOOL		binary;
	POINT 		pos;
	float 		newphase;
	float		oldphase;
	float 		mag;
	int 		newphaselevel;
	int 		oldphaselevel;
/* this mag is multiplied by all constants*/
} CHANGE_T;



inline COST operator+ (COST a,COST b){
        COST c;

        c.oldcost=a.oldcost+b.oldcost;
        c.newcost=a.newcost+b.newcost;
return c;
}

inline COST_DATA operator+ (COST_DATA a,COST_DATA b){
COST_DATA c;
        c.signal=a.signal+b.signal;
        c.noise=a.noise+b.noise;
return c;
}


inline COST_T operator+ (COST_T a,COST_T b){
COST_T c;
        c.newc=a.newc+b.newc;
        c.oldc=a.oldc+b.oldc;
return c;
}

